#include "mpi.h"
#include <stdio.h>
static long num_steps = 10000000;
double step;
int main (int argc, char *argv[])
{ 	int i; double x, pi, mypi = 0.0, sum=0.0;

        int rank;
        int size;

        MPI_Init(&argc,&argv);

        MPI_Comm_rank(MPI_COMM_WORLD,&rank);
        MPI_Comm_size(MPI_COMM_WORLD,&size);


 	step = 1.0/(double) num_steps;
  	for (i=rank;i< num_steps; i+=size){
		x = (i+0.5)*step;
		sum = sum + 4.0/(1.0+x*x);
	}
	mypi = step * sum;


        MPI_Reduce(&mypi, &pi, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);


        if (rank==0)
	   printf("Est Pi= %f\n",pi);
        

        MPI_Finalize();
}

