#include "mpi.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

int main(int argc, char *argv[])
{
    long in,i,n;
    double x,y,q,Q;
    time_t now;


    int rank,size;


    MPI_Init(&argc, &argv);
    in = 0;

    MPI_Comm_size(MPI_COMM_WORLD,&size);
    MPI_Comm_rank(MPI_COMM_WORLD,&rank);
    srand(time(&now)+rank);
    if (rank==0) {
       printf("Input no of samples : ");
       scanf("%ld",&n);
    }


    MPI_Bcast(&n,1,MPI_LONG,0,MPI_COMM_WORLD);
    for (i=0;i<n;i++)
    {
        x = rand()/(RAND_MAX+1.0);
        y = rand()/(RAND_MAX+1.0);

        if ((x*x + y*y) < 1)
        {
            in++;
        }
    }
    q = ((double)4.0)*in/n;


    MPI_Reduce(&q,&Q,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD);
    Q = Q / size;
    if (rank==0)  {
        printf("pi = %.20lf\n",Q);
        printf("rmse = %.20lf\n",sqrt(( (double) Q*(4-Q))/n/size)); 
    }


    MPI_Finalize();
}

